import { AbstractAuth, IAuthIdentity, IAccessDetails, GenericResult, IAuthData, IAuthOptions } from "@skazska/abstract-service-model";
export declare class JWTAuth extends AbstractAuth {
    /**
     * @param identityConstructor
     * @param options
     */
    constructor(identityConstructor: (subject: string, details: IAccessDetails, realm?: string) => IAuthIdentity, options?: IAuthOptions);
    /**
     * checks token and returns auth data
     * @param secret - secret to use
     * @param token - token
     * @param realm - realm to check
     */
    protected verify(secret: any, token: string, realm?: string): Promise<GenericResult<IAuthData>>;
    /**
     * generates token
     * @param details - auth details
     * @param subject - subject
     * @param realms - realms
     */
    grant(details: any, subject: string, realms?: string[]): Promise<GenericResult<string>>;
}
